aafig ou comment réaliser des diagrammes en restructuredtext
============================================================
![category](développement)
![tag](restructuredtext)
![tag](python)

Sphinx et restructuredText possèdent de nombreux plugins et souvent je ne suis
pas fan: l'objectif est d'avoir une documentation qu'on peut compiler
simplement ... si il faut commencer à ajouter des plugins.

Malgré cela j'utilise souvent 2 plugins indispensables:

#. sphinx_fontawesome: ajout d'icone sympa dans mes notes
#. sphinxcontrib-aafig: ajout de diagramme en mode text

Installation
------------

```bash
pip install sphinxcontrib-aafig
```

```warning
ce plugin ne fonctionne que sous python2.7 !!!
sa principale dépendance (aafigure) n'étant pas compatible python3
```

Utilisation
-----------

```python
extensions = ['sphinxcontrib.aafig']
```

et enfin si besoin modifier le fichier 	sphinxcontrib/aafig.py en ajoutant

```python
from docutils.parsers.rst import directives
#ADD BY FAO
from docutils.parsers.rst.directives import images
#END ADD BY FAO
```

ce plugin permet de générer des schéma via une description ASCII

```
premier exemple

.. aafig::
    :textual:

    +-------+         +-----------+
    | Hello +-------->+ aafigure! |
    +-------+         +-----------+

deuxième exemple

.. aafig::
    :textual:
    
      /---------\         +---------+     +---------+
      |  Shape  |         |  Line   |     |  Point  |
      +---------+         +---------+   2 +---------+
      | draw    +<--------+ start   +----O+ x       |
      | move    +<-+      | end     |     | y       |
      |         |   \     |         |     |         |   
      \---------/    \    +----+----+     +---------+
                      \        |
                       \       V
                        \  +---+-----+
                         +-+ Circle  |
                           +---------+
                           | center  |
                           | radius  |
                           +---------+	    

.. aafig::        
    :textual:

    +---------+  +---------+  +---------+
    |Object 1 |  |Object 2 |  |Object 3 |
    +----+----+  +----+----+  +----+----+
      |            |            |
      |            |            |
      X            |            |
      X----------->X            |
      X            X            |
      X<-----------X            |
      X            |            |
      X            |            |
      X------------------------>X
      |            |            X
      X----------->X            X---+
      X            X            X   |
      |            |            X<--+
      X<------------------------X
      X            |            |
      |            |            |
      |            |            |

```

premier exemple

.. aafig::
    :textual:

    +-------+         +-----------+
    | Hello +-------->+ aafigure! |
    +-------+         +-----------+

deuxième exemple

.. aafig::
    :textual:
    
    /---------\         +---------+     +---------+
    |  Shape  |         |  Line   |     |  Point  |
    +---------+         +---------+   2 +---------+
    | draw    +<--------+ start   +----O+ x       |
    | move    +<-+      | end     |     | y       |
    |         |   \     |         |     |         |
    \---------/    \    +----+----+     +---------+
                    \        |
                     \       V
                      \  +---+-----+
                       +-+ Circle  |
                         +---------+
                         | center  |
                         | radius  |
                         +---------+	  


.. aafig::        
    :textual:

    +---------+  +---------+  +---------+
    |Object 1 |  |Object 2 |  |Object 3 |
    +----+----+  +----+----+  +----+----+
      |            |            |
      |            |            |
      X            |            |
      X----------->X            |
      X            X            |
      X<-----------X            |
      X            |            |
      X            |            |
      X------------------------>X
      |            |            X
      X----------->X            X---+
      X            X            X   |
      |            |            X<--+
      X<------------------------X
      X            |            |
      |            |            |
      |            |            |

Il existe un tutorial sur aafigure sur https://launchpadlibrarian.net/41870218/aafigure.pdf


```note
si vous souhaitez avec aafigure générer des images png ou jpg il faut 

* ajouter dans conf.py

```
aafig_format = dict(latex='pdf', html='png', text=None)
```

* installer PIL via

.. code-block:: bash

    pip uninstall pil
    pil install Pillow
```

Intégration dans Ablog
----------------------

Pour l'intégration dans ablog il faut utiliser une version personnel (qui change 
la gestion du pathimg) qu'on peut trouver sur https://github.com/fraoustin/sphinxcontrib















